/*
 *                      ***** TA Pattern Search Server Main *****
 *
 *                      Transparent Architecture
 *
 *   Copyright (c) 2012 Dmitry Dagaev. All rights reserved.
 *
 */

#include "fsrch.h"

const char *pattern, *file_name;
/* ------------------------------------------------------- */
int main(int argc, char **argv)
{
	TaArea area;
	TaAreaQos aqos;
	TaLong aid = 19;
	TaStation stations[MAX_STATIONS];
	TaStationQos sqos;
	TaChannelQos cqos;
	int i, my_sid_number = 0, stations_amount = MAX_STATIONS;
	char **args;
	pattern = "="; file_name = "srch.cfg";

	taInitialize();
	taDefaultAreaQos(&aqos);
	taDefaultStationQos(&sqos);
	taDefaultChannelQos(&cqos);
	aqos.tp_cycle = 100000;
	strcpy(sqos.hostname, "127.0.0.1");
	sqos.first_port = 8000;
	sqos.enable_mask = TA_ENABLE_UDP_MCAST;
	cqos.check_host_ip = _False;
	taInitArea(aid, &aqos, "psrch", &area);
	taReallocStations(MAX_STATIONS, &area);
	args = taArgsFromConfig("srch.cfg");

	if (args)
		{
	for (i = 0; args[i]; i++) {
		if (!strcmp("t", args[i]) || !strcmp("trace_level", argv[i])) {
			if (args[i+1])
				taTrace(ta_trace_level = atoi(args[i+1]), NULL);
			++i;
		} else if (!strcmp("e", args[i]) || !strcmp("protocol", argv[i])) {
			if (args[i+1]) {
				aqos.enable_mask =
				sqos.enable_mask =
					atoi(args[i+1]);
				taInitArea(aid, &aqos, "psrch", &area);
				taReallocStations(MAX_STATIONS, &area);
			}
			++i;
		} else if (!strcmp("c", args[i])) {
			if (args[i+1])
				area.qos.tp_cycle = atoi(args[i+1]);
			if (area.qos.tp_cycle < 1000)
				area.qos.tp_cycle = 1000;
			if (area.qos.tp_cycle > 10000000)
				area.qos.tp_cycle = 10000000;
			++i;
		} else if (!strcmp("a", args[i])) {
			if (args[i+1])
				area.aid = aid = (TaLong)atoi(args[i+1]);
			++i;
		} else if (!strcmp("port", args[i])) {
			if (args[i+1])
				sqos.first_port = atoi(args[i+1]);
			++i;
		} else if (!strcmp("n_stations", args[i])) {
			if (args[i+1])
				stations_amount = atoi(args[i+1]);
			++i;
		} else if (!strcmp("pattern", args[i])) {
			if (args[i+1])
				pattern = args[i+1];
			++i;
		} else if (!strcmp("file_name", args[i])) {
			if (args[i+1])
				file_name = args[i+1];
			++i;
		}
	}
	taClearArgs(args); args = NULL;
		}
	for (i = 0; i < stations_amount; i++)
		taInitStation(i, &sqos, &cqos, NULL, &area, 
			&stations[i]);

	taSetStationHostBySid(my_sid_number, &area);
	taInitStationsData(&area);

	SearchServerInit(&area);

	taRun(&area, &my_sid_number);

	taCloseStationsData(&area);
	return 0;
}

