MODULE Files;
(** 
	project	= "Transparent Architecture"
	organization	= "http://sourceforge.net/"
	contributors	= "Dmitry V.Dagaev"
	license = "LGPL"
**)

	CONST
		dontAsk* = FALSE; ask* = TRUE;
	
	TYPE
		Name* = ARRAY 256 OF CHAR;
		Type* = ARRAY 16 OF CHAR;

		FileDesc* = RECORD
			type-: Type;
			init: BOOLEAN;
		END;
		File* = POINTER TO FileDesc;


		ReaderDesc* = RECORD
			eof*: BOOLEAN;
		END;
		Reader* = POINTER TO ReaderDesc;

		WriterDesc* = RECORD END;
		Writer* = POINTER TO WriterDesc;


	PROCEDURE (f: File) InitType* (type: Type);
	BEGIN
		ASSERT(~f.init, 20);
		f.type := type; f.init := TRUE
	END InitType;

	PROCEDURE (f: File) Length* (): LONGINT;
	BEGIN RETURN 0 END Length;
	PROCEDURE (f: File) NewReader* (old: Reader): Reader;
	BEGIN RETURN NIL END NewReader;
	PROCEDURE (f: File) NewWriter* (old: Writer): Writer;
	BEGIN RETURN NIL END NewWriter;
	PROCEDURE (f: File) Flush* ();
	BEGIN END Flush;
	PROCEDURE (f: File) Register* (name: Name; type: Type; ask: BOOLEAN;
													VAR res: INTEGER);
	BEGIN END Register;
	PROCEDURE (f: File) Close* ();
	BEGIN END Close;
	
	PROCEDURE (r: Reader) Base* (): File;
	BEGIN RETURN NIL END Base;
	PROCEDURE (r: Reader) Pos* (): LONGINT;
	BEGIN RETURN 0 END Pos;
	PROCEDURE (r: Reader) SetPos* (pos: LONGINT);
	BEGIN END SetPos;
	PROCEDURE (r: Reader) ReadByte* (VAR x: SHORTINT);
	BEGIN END ReadByte;
	PROCEDURE (r: Reader) ReadBytes* (VAR x: ARRAY OF SHORTINT; 
	beg, len: LONGINT);
	BEGIN END ReadBytes;
	
	PROCEDURE (w: Writer) Base* (): File;
	BEGIN RETURN NIL END Base;
	PROCEDURE (w: Writer) Pos* (): LONGINT;
	BEGIN RETURN 0 END Pos;
	PROCEDURE (w: Writer) SetPos* (pos: LONGINT);
	BEGIN END SetPos;
	PROCEDURE (w: Writer) WriteByte* (x: SHORTINT);
	BEGIN END WriteByte;
	PROCEDURE (w: Writer) WriteBytes* (x-: ARRAY OF SHORTINT; 
	beg, len: LONGINT);
	BEGIN END WriteBytes;
	
END Files.

