MODULE Ta_NoahsArkEC;
(** 
	project	= "Transparent Architecture"
	organization	= "http://sourceforge.net/"
	contributors	= "Dmitry V.Dagaev"
	license = "LGPL"
**)

	IMPORT Tb := Ta_Basics, Ta_CfgTInfo, Tc := Ta_Channels, Ta := Ta_Areas, Ts := Ta_Stations,
		Ti := Ta_TInfo, Ta_STAreas, Log;
	
	CONST
		WITH_TICK_CORRECT = TRUE; MAX_STATIONS = 2;
		
	TYPE 
		Troyka* = RECORD (Tb.AnyRec)
			horses* : ARRAY 3 OF Tb.Char8;
			chariot* : Tb.Int16;
		END;
		MyString* = RECORD (Tb.AnyRec)
			str* : POINTER TO ARRAY OF Tb.Char8;
		END;
		NoahsArk* = RECORD (Tb.AnyRec)
			dove_female* : Tb.Char8;
			dove_male* : Tb.Char16;
			raven_female* : Tb.Int8;
			raven_male* : Tb.Int16;
			olive* : BOOLEAN;
			domestic* : Tb.Int64;
			wild* : Tb.Int32;
			human_female* : Tb.Real32;
			human_male* : Tb.Real64;
			bees* : ARRAY 6 OF Tb.Int8;
			cows* : ARRAY 2 OF Tb.Int64;
			name* : ARRAY 13 OF Tb.Char16;
			sname* : ARRAY 11 OF Tb.Char8;
			troyka* : Troyka;
			olives* : POINTER TO ARRAY OF BOOLEAN;
			troykas* : POINTER TO ARRAY OF Troyka;
			strings* : POINTER TO ARRAY OF MyString;
			tro* : ARRAY 3 OF Troyka;
		END;

		Opts* = RECORD (Tb.AnyRec)
			protocol*: Tb.Name16;
			hosts*: ARRAY 256 OF CHAR; 
		END;
		
	VAR
		table: Ta.Table;
		noahsArk*, sendArk: NoahsArk;
		area: Ta.Area;
		ti, myti: Ta_CfgTInfo.TInfo;
		opts*: Opts;

	(* -----------------------  Test Nodex  ----------------------- *)
	PROCEDURE HandleMessage(t: Ta.Table; prod: Ta.ProData);
		VAR i: INTEGER; s: Tb.Name;
	BEGIN
		IF prod.res = 0 THEN
			Log.Char(noahsArk.dove_female); Log.Char(Tb.C16_C(noahsArk.dove_male)); 
			Log.String(" human:"); Log.Real(noahsArk.human_female); 
			Log.Real(noahsArk.human_male);
			Log.String(" bees:"); Log.Int(noahsArk.bees[0]);Log.Int(noahsArk.bees[1]);
			Log.String(" cows:"); Log.Int(Tb.Int64_Int32(noahsArk.cows[0])); 		
			Log.Int(Tb.Int64_Int32(noahsArk.cows[1]));
			Tb.Char16_Char(noahsArk.name, s); Log.String(s); Log.String(" ");
			Tb.Char8_Char(noahsArk.sname, s); Log.String(s); 
			Log.String(" "); Log.Char(noahsArk.troyka.horses[0]); Log.Char(noahsArk.troyka.horses[1]);
			Log.Char(noahsArk.troyka.horses[2]);Log.Int(noahsArk.troyka.chariot);
			Log.String(" |"); Log.Char(noahsArk.tro[0].horses[0]); Log.Char(noahsArk.tro[0].horses[1]);
			Log.Char(noahsArk.tro[0].horses[2]);Log.Int(noahsArk.tro[0].chariot);
			Log.String(" |"); Log.Char(noahsArk.tro[1].horses[0]); Log.Char(noahsArk.tro[1].horses[1]);
			Log.Char(noahsArk.tro[2].horses[2]);Log.Int(noahsArk.tro[1].chariot);
			Log.String(" |"); Log.Char(noahsArk.tro[2].horses[0]); Log.Char(noahsArk.tro[2].horses[1]);
			Log.Char(noahsArk.tro[2].horses[2]);Log.Int(noahsArk.tro[2].chariot);
			FOR i := 0 TO LEN(noahsArk.olives^)-1 DO Log.Bool(noahsArk.olives[i]); END;
			FOR i := 0 TO LEN(noahsArk.troykas^)-1 DO 
				Log.Char(noahsArk.troykas[i].horses[0]); Log.Char(noahsArk.troykas[i].horses[1]);
				Log.Char(noahsArk.troykas[i].horses[2]); Log.Int(noahsArk.troykas[i].chariot);
			END;
			FOR i := 0 TO LEN(noahsArk.strings^)-1 DO
				IF noahsArk.strings[i].str # NIL THEN
					Log.String(":"); Log.Int(LEN(noahsArk.strings[i].str^));  Log.Char('.');
					Tb.Char8_Char(noahsArk.strings[i].str^, s);
					Log.String(s);
				END
			END;
			Log.Ln;
		ELSE
			Log.String("*** error:"); Log.Int(prod.res); Log.Ln;
		END
	END HandleMessage;
	
	PROCEDURE NoahsArkUpdate(area: Ta.Area; par: Tb.AnyPtr);
		VAR dove: CHAR; raven: Tb.Int16; s: Tb.Name;
	BEGIN
		(* send *)
		sendArk.olive := ~sendArk.olive;
		dove := Tb.C16_C(sendArk.dove_male); sendArk.dove_male := Tb.C_C16(sendArk.dove_female);
		sendArk.dove_female := Tb.C_C8(dove); raven:= sendArk.raven_male; 
		sendArk.raven_male:= sendArk.raven_female; sendArk.raven_female:= SHORT(raven);
		IF sendArk.olive THEN
			sendArk.human_female := 1.234;
			sendArk.human_male := 4.321;
			sendArk.bees[0] := 1;
			sendArk.bees[1] := 2;
			sendArk.cows[0] := Tb.Long_Int64(123);
			sendArk.cows[1] := Tb.Long_Int64(456);
			sendArk.troyka.horses[0] := 'A';
			sendArk.troyka.horses[1] := 'B';
			sendArk.troyka.horses[2] := 'C';
			sendArk.troyka.chariot := 99;
			Tb.Char_Char16("Noahs Ark", sendArk.name);
		ELSE
			sendArk.human_female := 4.321;
			sendArk.human_male := 1.234;
			sendArk.bees[0] := 2;
			sendArk.bees[1] := 1;
			sendArk.cows[0] := Tb.Long_Int64(456);
			sendArk.cows[1] := Tb.Long_Int64(123);
			sendArk.troyka.horses[0] := 'a';
			sendArk.troyka.horses[1] := 'b';
			sendArk.troyka.horses[2] := 'c';
			sendArk.troyka.chariot := 88;
			Tb.Char_Char16("Noahs Ark1", sendArk.name);
		END;
		(* send to other of pair *)
		table.Write(sendArk, FALSE);
	END NoahsArkUpdate;
		
	PROCEDURE Stop*;
	BEGIN
		IF area # NIL THEN
			area.Finish(Ta.NORMAL_FINISH);
			area := NIL
		END
	END Stop;
	
	PROCEDURE Ark*;
		VAR aqos: Ta.AreaQos; cqos: Tc.ChannelQos; tqos: Ts.TableQos; res: INTEGER; 
		s: Tb.Name; ti_troyka, ti_mystring: Ti.TInfo; 
	BEGIN
		myti.InitFromCommandLine(Ta.dir.command_line, Ta.dir.ind_command_line);
		aqos := Ta.defaultAQos;
		area := Ta.dir.NewArea(69, "NoahsArk", 2, aqos);
		cqos := Tc.defaultCQos;
		cqos.protocol := opts.protocol;
		cqos.trust_src_sid := TRUE;
		area.AddUpdater(NoahsArkUpdate, NIL, 0);
		area.AddStations(opts.hosts, Ta.APPEND_AS_LIST, -1, cqos, res);
		ASSERT(res = 0, 102);
		tqos := Ts.defaultTQos;
		tqos.realloc_mode := Ts.DONT_REALLOC;
		NEW(noahsArk.olives, 3);
		NEW(noahsArk.troykas, 2);
		NEW(noahsArk.strings, 2);
		NEW(noahsArk.strings[0].str, 32); 
		NEW(noahsArk.strings[1].str, 32);
		table := area.NewTable(noahsArk, "Tests.INoahsArk", "NoahsArk", 
			Ts.sendSID, 0, tqos, HandleMessage);
		(* Insert RTTI: no action on BB, used for XDS compatibility *)
		NEW(ti_troyka); ti_troyka.ConnectTo(Tb.no_rec, "Ta_NoahsArkEC", 
			"Troyka", NIL); 
		NEW(ti_mystring); ti_mystring.ConnectTo(Tb.no_rec, "Ta_NoahsArkEC", 
			"MyString", NIL);
		ti_troyka.Insert(0, "horses", Tb.char8Typ, Tb.exported, 3, NIL);
		ti_troyka.Insert(1, "chariot", Tb.int16Typ, Tb.exported, 1, NIL);
		ti_mystring.Insert(0, "str", Tb.char8Typ, Tb.exported, -32, NIL);
		table.ti.Insert(0, "dove_female", Tb.char8Typ, Tb.exported, 1, NIL);
		table.ti.Insert(1, "dove_male", Tb.char16Typ, Tb.exported, 1, NIL);
		table.ti.Insert(2, "raven_female", Tb.int8Typ, Tb.exported, 1, NIL);
		table.ti.Insert(3, "raven_male", Tb.int16Typ, Tb.exported, 1, NIL);
		table.ti.Insert(4, "olive", Tb.boolTyp, Tb.exported, 1, NIL);
		table.ti.Insert(5, "domestic", Tb.int64Typ, Tb.exported, 1, NIL);
		table.ti.Insert(6, "wild", Tb.int32Typ, Tb.exported, 1, NIL);
		table.ti.Insert(7, "human_female", Tb.real32Typ, Tb.exported, 1, NIL);
		table.ti.Insert(8, "human_male", Tb.real64Typ, Tb.exported, 1, NIL);
		table.ti.Insert(9, "bees", Tb.int8Typ, Tb.exported, 6, NIL);
		table.ti.Insert(10, "cows", Tb.int64Typ, Tb.exported, 2, NIL);
		table.ti.Insert(11, "name", Tb.char16Typ, Tb.exported, 13, NIL);
		table.ti.Insert(12, "sname", Tb.char8Typ, Tb.exported, 11, NIL);
		table.ti.Insert(13, "troyka", Tb.recTyp, Tb.exported, 1, ti_troyka);
		table.ti.Insert(14, "olives", Tb.boolTyp, Tb.exported, -3, NIL);
		table.ti.Insert(15, "troykas", Tb.recTyp, Tb.exported, -2, ti_troyka);
		table.ti.Insert(16, "strings", Tb.recTyp, Tb.exported, -2, ti_mystring);
		table.ti.Insert(17, "tro", Tb.recTyp, Tb.exported, 3, ti_troyka);

		sendArk.dove_female := 'd';	(* dove *)
		sendArk.dove_male := Tb.C_C16('D');
		sendArk.raven_female := 6;	(* the book of Genesis 6-9 *)
		sendArk.raven_male := 9;
		sendArk.olive := TRUE;
		sendArk.wild := area.HostSid();
		sendArk.domestic := Tb.Long_Int64(1-area.HostSid());
		sendArk.human_female := 1.234;
		sendArk.human_male := 4.321;
		Tb.Char_Char16("Noahs Ark", sendArk.name);
		sendArk.sname := "noahs ark";
		NEW(sendArk.olives, 3);
		sendArk.olives[0] := TRUE; sendArk.olives[1] := FALSE; sendArk.olives[2] := TRUE;
		NEW(sendArk.troykas, 2);
		sendArk.troykas[0].horses[0] := 'x'; sendArk.troykas[0].horses[1] := 'y';
		sendArk.troykas[0].horses[2] := 'z'; sendArk.troykas[1].horses[0] := 'X';
		sendArk.troykas[1].horses[1] := 'Y';sendArk.troykas[1].horses[2] := 'Z';
		sendArk.troykas[0].chariot := 11; sendArk.troykas[1].chariot := 12;
		NEW(sendArk.strings, 2);
		NEW(sendArk.strings[0].str, 6); Tb.Copy8('first', sendArk.strings[0].str^);
		NEW(sendArk.strings[1].str, 18); Tb.Copy8('the second string', sendArk.strings[1].str^);
		sendArk.tro[0].horses[0] := '1';sendArk.tro[0].horses[1] := '2';sendArk.tro[0].horses[2] := '3';
		sendArk.tro[1].horses[0] := '4';sendArk.tro[1].horses[1] := '5';sendArk.tro[1].horses[2] := '6';
		sendArk.tro[2].horses[0] := '7';sendArk.tro[2].horses[1] := '8';sendArk.tro[2].horses[2] := '9';
		sendArk.tro[0].chariot := 31;sendArk.tro[1].chariot := 32;sendArk.tro[2].chariot := 33;
		area.Start
	END Ark;

	PROCEDURE ArkCmd* (s, hosts: ARRAY OF CHAR);
	BEGIN
		ti.InitFromCommandLine(s, 0);
		myti.InitFromCommandLine(s, 0);
		Tb.Copy(hosts, opts.hosts);
		Ark
	END ArkCmd;

	PROCEDURE Initialize;
	BEGIN
		NEW(ti); ti.cfg_file := "-";
		NEW(myti);
		myti.ConnectTo(opts, "", "", NIL);
		(* Insert RTTI: no action on BB, used for XDS compatibility *)
		myti.Insert(0, "protocol", Tb.charTyp, Tb.exported, 16, NIL);
		myti.Insert(1, "hosts", Tb.charTyp, Tb.exported, 256, NIL);
		opts.protocol := "UDP";

		Ta.dir.InitModule('Ta_NoahsArkEC', 'NOAHS_ARK', Ark, ti, Ta.defaultDQos);
	END Initialize;

BEGIN
	Initialize		
END Ta_NoahsArkEC.
