MODULE Ta_Lib;
(** 
	project	= "Transparent Architecture"
	organization	= "http://sourceforge.net/"
	contributors	= "Dmitry V.Dagaev"
	license = "LGPL"
**)

	IMPORT SYSTEM, WinSock, WinBase, WinDef;
	
	CONST
		WSA_VER22* = 514; WSADESCRIPTION_LEN = 256; WSASYS_STATUS_LEN = 128;
		AF_UNSPEC*       = 0;           (* unspecified *)
		AF_UNIX*         = 1;               (* local to host (pipes, portals) *)
		AF_INET*         = 2;               (* internetwork: UDP, TCP, etc. *)
		AF_IMPLINK*      = 3;            (* arpanet imp addresses *)
		AF_PUP*          = 4;               (* pup protocols: e.g. BSP *)
		AF_CHAOS*        = 5;            (* mit CHAOS protocols *)
		AF_IPX*          = 6;                (* IPX and SPX *)
		AF_NS*           = 6;                (* XEROX NS protocols *)
		AF_ISO*          = 7;                (* ISO protocols *)
		AF_OSI*          = AF_ISO;      (* OSI is ISO *)
		AF_ECMA*         = 8;             (* european computer manufacturers *)
		AF_DATAKIT*      = 9;            (* datakit protocols *)
		AF_CCITT*        = 10;            (* CCITT protocols, X.25 etc *)
		AF_SNA*          = 11;             (* IBM SNA *)
		AF_DECnet*       = 12;           (* DECnet *)
		AF_DLI*          = 13;              (* Direct data link interface *)
		AF_LAT*          = 14;              (* LAT *)
		AF_HYLINK*       = 15;           (* NSC Hyperchannel *)
		AF_APPLETALK*    = 16;       (* AppleTalk *)
		AF_NETBIOS*      = 17;          (* NetBios-style addresses *)
		AF_VOICEVIEW*    = 18;       (* VoiceView *)
		AF_MAX*          = 19;
		SOCK_STREAM* = 1; SOCK_DGRAM* = 2; SOCK_RAW* = 3; 
			SOCK_RDM* = 4; SOCK_SEQPACKET*  = 5;
		SO_REUSEADDR* = 2;
		SO_KEEPALIVE* = 9;
		SO_DONTROUTE* = 5;
		SOL_SOCKET* = 1; 			
		MAX_FD_SET* = 64;
		FIONBIO* = -2147195266;
		(*FIONBIO* = WinSock.FIONBIO;*)
		MSG_NOSIGNAL* = 0;
		NI_MAXHOST* = 1025; NI_MAXSERV* = 32;
		NI_NUMERICHOST* = 2; NI_NUMERICSERV* = 8;
		IPPROTO_IP* = 0; IPPROTO_TCP* = 6;
		IP_ADD_MEMBERSHIP* = 12; 
		IP_MULTICAST_TTL* = 10; IP_MULTICAST_LOOP* = 11;
		TCP_NODELAY* = 1;
		EWOULDBLOCK* = WinSock.WSAEWOULDBLOCK;
		EINPROGRESS* = WinSock.WSAEINPROGRESS;
		EISCONN* = WinSock.WSAEISCONN;
		ECONNRESET* = 10054; 
		ECONNABORTED* = 10053; ESHUTDOWN* = 10058;
		ERROR_ALREADY_EXISTS* = 183;

		INVALID_HANDLE_VALUE* = -1; PAGE_READONLY* = 2; PAGE_READWRITE* = 4;
		FILE_MAP_WRITE* = 2; FILE_MAP_READ* = 4; OF_READ* = 0; OF_READWRITE* = 2;
		GET_FILE_EX_INFO_STANDARD* = 0; FILE_MAP_ALL_ACCESS* = 983071;

	
	TYPE
		WSAData* = WinSock.WSADATA; 
		timeval* = WinSock.timeval;

		SOCKET* = WinSock.SOCKET;
		in_addr* = WinSock.in_addr;
		sockaddr_in* = WinSock.sockaddr_in;
		sockaddr* = WinSock.sockaddr;
		phostent* = WinSock.p_hostent;
		PtrSTR* = WinDef.PSTR;
		pbyte* = WinDef.PCBYTE;
		fd_set* = WinSock.fd_set;
		pfd_set* = SYSTEM.ADDRESS;
		FD_FLAGS* = POINTER TO ARRAY OF WinSock.FD_FLAGS;
		fd_flags* = RECORD
			ws_flags*: WinSock.FD_FLAGS;
			fd_array*: ARRAY MAX_FD_SET OF SOCKET;
		END;
		ip_mreq* = RECORD
			imr_multiaddr*, imr_interface*: in_addr
		END;
		psockaddr* = POINTER TO sockaddr;
		

		file_attribute_data* = RECORD
			dwFileAttributes-: LONGINT;
			ftCreationTime-, ftLastAccessTime-, ftLastWriteTime-: WinBase.FILETIME;
			nFileSizeHigh*, nFileSizeLow*: LONGINT;
			dummy: ARRAY 256 OF LONGINT;
		END;

	PROCEDURE ["C"] / getnameinfo*(sa-: sockaddr; salen: LONGINT;
	host: pbyte; hostlen: LONGINT; serv: pbyte; servlen, flags: LONGINT) : LONGINT;
	PROCEDURE ["C"] / select*(n: SYSTEM.CARD32; VAR rf: fd_set; VAR wf: fd_set;
	VAR ef: fd_set; VAR tv: timeval): LONGINT;


END Ta_Lib.
